%% bare_conf.tex
%% V1.4b
%% 2015/08/26
%% by Michael Shell
%% See:
%% http://www.michaelshell.org/
%% for current contact information.
%%
%% This is a skeleton file demonstrating the use of IEEEtran.cls
%% (requires IEEEtran.cls version 1.8b or later) with an IEEE
%% conference paper.
%%
%% Support sites:
%% http://www.michaelshell.org/tex/ieeetran/
%% http://www.ctan.org/pkg/ieeetran
%% and
%% http://www.ieee.org/

%%*************************************************************************
%% Legal Notice:
%% This code is offered as-is without any warranty either expressed or
%% implied; without even the implied warranty of MERCHANTABILITY or
%% FITNESS FOR A PARTICULAR PURPOSE! 
%% User assumes all risk.
%% In no event shall the IEEE or any contributor to this code be liable for
%% any damages or losses, including, but not limited to, incidental,
%% consequential, or any other damages, resulting from the use or misuse
%% of any information contained here.
%%
%% All comments are the opinions of their respective authors and are not
%% necessarily endorsed by the IEEE.
%%
%% This work is distributed under the LaTeX Project Public License (LPPL)
%% ( http://www.latex-project.org/ ) version 1.3, and may be freely used,
%% distributed and modified. A copy of the LPPL, version 1.3, is included
%% in the base LaTeX documentation of all distributions of LaTeX released
%% 2003/12/01 or later.
%% Retain all contribution notices and credits.
%% ** Modified files should be clearly indicated as such, including  **
%% ** renaming them and changing author support contact information. **
%%*************************************************************************


% *** Authors should verify (and, if needed, correct) their LaTeX system  ***
% *** with the testflow diagnostic prior to trusting their LaTeX platform ***
% *** with production work. The IEEE's font choices and paper sizes can   ***
% *** trigger bugs that do not appear when using other class files.       ***                          ***
% The testflow support page is at:
% http://www.michaelshell.org/tex/testflow/



\documentclass[conference]{IEEEtran}
% Some Computer Society conferences also require the compsoc mode option,
% but others use the standard conference format.
%
% If IEEEtran.cls has not been installed into the LaTeX system files,
% manually specify the path to it like:
% \documentclass[conference]{../sty/IEEEtran}

\usepackage[utf8]{inputenc}



% Some very useful LaTeX packages include:
% (uncomment the ones you want to load)


% *** MISC UTILITY PACKAGES ***
%
% \usepackage{ifpdf}
% Heiko Oberdiek's ifpdf.sty is very useful if you need conditional
% compilation based on whether the output is pdf or dvi.
% usage:
% \ifpdf
%   % pdf code
% \else
%   % dvi code
% \fi
% The latest version of ifpdf.sty can be obtained from:
% http://www.ctan.org/pkg/ifpdf
% Also, note that IEEEtran.cls V1.7 and later provides a builtin
% \ifCLASSINFOpdf conditional that works the same way.
% When switching from latex to pdflatex and vice-versa, the compiler may
% have to be run twice to clear warning/error messages.






% *** CITATION PACKAGES ***
%
%\usepackage{cite}
% cite.sty was written by Donald Arseneau
% V1.6 and later of IEEEtran pre-defines the format of the cite.sty package
% \cite{} output to follow that of the IEEE. Loading the cite package will
% result in citation numbers being automatically sorted and properly
% "compressed/ranged". e.g., [1], [9], [2], [7], [5], [6] without using
% cite.sty will become [1], [2], [5]--[7], [9] using cite.sty. cite.sty's
% \cite will automatically add leading space, if needed. Use cite.sty's
% noadjust option (cite.sty V3.8 and later) if you want to turn this off
% such as if a citation ever needs to be enclosed in parenthesis.
% cite.sty is already installed on most LaTeX systems. Be sure and use
% version 5.0 (2009-03-20) and later if using hyperref.sty.
% The latest version can be obtained at:
% http://www.ctan.org/pkg/cite
% The documentation is contained in the cite.sty file itself.






% *** GRAPHICS RELATED PACKAGES ***
%
\usepackage[pdftex]{graphicx}
\usepackage{subcaption}
% declare the path(s) where your graphic files are
\graphicspath{{./fig/}}
% and their extensions so you won't have to specify these with
% every instance of \includegraphics
\DeclareGraphicsExtensions{.pdf,.jpeg,.png}
% graphicx was written by David Carlisle and Sebastian Rahtz. It is
% required if you want graphics, photos, etc. graphicx.sty is already
% installed on most LaTeX systems. The latest version and documentation
% can be obtained at: 
% http://www.ctan.org/pkg/graphicx
% Another good source of documentation is "Using Imported Graphics in
% LaTeX2e" by Keith Reckdahl which can be found at:
% http://www.ctan.org/pkg/epslatex
%
% latex, and pdflatex in dvi mode, support graphics in encapsulated
% postscript (.eps) format. pdflatex in pdf mode supports graphics
% in .pdf, .jpeg, .png and .mps (metapost) formats. Users should ensure
% that all non-photo figures use a vector format (.eps, .pdf, .mps) and
% not a bitmapped formats (.jpeg, .png). The IEEE frowns on bitmapped formats
% which can result in "jaggedy"/blurry rendering of lines and letters as
% well as large increases in file sizes.
%
% You can find documentation about the pdfTeX application at:
% http://www.tug.org/applications/pdftex

\usepackage{pgfplots}

% *** MATH PACKAGES ***
%
\usepackage{amsmath}
% A popular package from the American Mathematical Society that provides
% many useful and powerful commands for dealing with mathematics.
%
% Note that the amsmath package sets \interdisplaylinepenalty to 10000
% thus preventing page breaks from occurring within multiline equations. Use:
\interdisplaylinepenalty=2500
% after loading amsmath to restore such page breaks as IEEEtran.cls normally
% does. amsmath.sty is already installed on most LaTeX systems. The latest
% version and documentation can be obtained at:
% http://www.ctan.org/pkg/amsmath
\usepackage{mathrsfs}





% *** SPECIALIZED LIST PACKAGES ***
%
%\usepackage{algorithmic}
% algorithmic.sty was written by Peter Williams and Rogerio Brito.
% This package provides an algorithmic environment fo describing algorithms.
% You can use the algorithmic environment in-text or within a figure
% environment to provide for a floating algorithm. Do NOT use the algorithm
% floating environment provided by algorithm.sty (by the same authors) or
% algorithm2e.sty (by Christophe Fiorio) as the IEEE does not use dedicated
% algorithm float types and packages that provide these will not provide
% correct IEEE style captions. The latest version and documentation of
% algorithmic.sty can be obtained at:
% http://www.ctan.org/pkg/algorithms
% Also of interest may be the (relatively newer and more customizable)
% algorithmicx.sty package by Szasz Janos:
% http://www.ctan.org/pkg/algorithmicx




% *** ALIGNMENT PACKAGES ***
%
%\usepackage{array}
% Frank Mittelbach's and David Carlisle's array.sty patches and improves
% the standard LaTeX2e array and tabular environments to provide better
% appearance and additional user controls. As the default LaTeX2e table
% generation code is lacking to the point of almost being broken with
% respect to the quality of the end results, all users are strongly
% advised to use an enhanced (at the very least that provided by array.sty)
% set of table tools. array.sty is already installed on most systems. The
% latest version and documentation can be obtained at:
% http://www.ctan.org/pkg/array


% IEEEtran contains the IEEEeqnarray family of commands that can be used to
% generate multiline equations as well as matrices, tables, etc., of high
% quality.




% *** SUBFIGURE PACKAGES ***
%\ifCLASSOPTIONcompsoc
%  \usepackage[caption=false,font=normalsize,labelfont=sf,textfont=sf]{subfig}
%\else
%  \usepackage[caption=false,font=footnotesize]{subfig}
%\fi
% subfig.sty, written by Steven Douglas Cochran, is the modern replacement
% for subfigure.sty, the latter of which is no longer maintained and is
% incompatible with some LaTeX packages including fixltx2e. However,
% subfig.sty requires and automatically loads Axel Sommerfeldt's caption.sty
% which will override IEEEtran.cls' handling of captions and this will result
% in non-IEEE style figure/table captions. To prevent this problem, be sure
% and invoke subfig.sty's "caption=false" package option (available since
% subfig.sty version 1.3, 2005/06/28) as this is will preserve IEEEtran.cls
% handling of captions.
% Note that the Computer Society format requires a larger sans serif font
% than the serif footnote size font used in traditional IEEE formatting
% and thus the need to invoke different subfig.sty package options depending
% on whether compsoc mode has been enabled.
%
% The latest version and documentation of subfig.sty can be obtained at:
% http://www.ctan.org/pkg/subfig




% *** FLOAT PACKAGES ***
%
%\usepackage{fixltx2e}
% fixltx2e, the successor to the earlier fix2col.sty, was written by
% Frank Mittelbach and David Carlisle. This package corrects a few problems
% in the LaTeX2e kernel, the most notable of which is that in current
% LaTeX2e releases, the ordering of single and double column floats is not
% guaranteed to be preserved. Thus, an unpatched LaTeX2e can allow a
% single column figure to be placed prior to an earlier double column
% figure.
% Be aware that LaTeX2e kernels dated 2015 and later have fixltx2e.sty's
% corrections already built into the system in which case a warning will
% be issued if an attempt is made to load fixltx2e.sty as it is no longer
% needed.
% The latest version and documentation can be found at:
% http://www.ctan.org/pkg/fixltx2e


%\usepackage{stfloats}
% stfloats.sty was written by Sigitas Tolusis. This package gives LaTeX2e
% the ability to do double column floats at the bottom of the page as well
% as the top. (e.g., "\begin{figure*}[!b]" is not normally possible in
% LaTeX2e). It also provides a command:
%\fnbelowfloat
% to enable the placement of footnotes below bottom floats (the standard
% LaTeX2e kernel puts them above bottom floats). This is an invasive package
% which rewrites many portions of the LaTeX2e float routines. It may not work
% with other packages that modify the LaTeX2e float routines. The latest
% version and documentation can be obtained at:
% http://www.ctan.org/pkg/stfloats
% Do not use the stfloats baselinefloat ability as the IEEE does not allow
% \baselineskip to stretch. Authors submitting work to the IEEE should note
% that the IEEE rarely uses double column equations and that authors should try
% to avoid such use. Do not be tempted to use the cuted.sty or midfloat.sty
% packages (also by Sigitas Tolusis) as the IEEE does not format its papers in
% such ways.
% Do not attempt to use stfloats with fixltx2e as they are incompatible.
% Instead, use Morten Hogholm'a dblfloatfix which combines the features
% of both fixltx2e and stfloats:
%
% \usepackage{dblfloatfix}
% The latest version can be found at:
% http://www.ctan.org/pkg/dblfloatfix




% *** PDF, URL AND HYPERLINK PACKAGES ***
%
%\usepackage{url}
% url.sty was written by Donald Arseneau. It provides better support for
% handling and breaking URLs. url.sty is already installed on most LaTeX
% systems. The latest version and documentation can be obtained at:
% http://www.ctan.org/pkg/url
% Basically, \url{my_url_here}.




% *** Do not adjust lengths that control margins, column widths, etc. ***
% *** Do not use packages that alter fonts (such as pslatex).         ***
% There should be no need to do such things with IEEEtran.cls V1.6 and later.
% (Unless specifically asked to do so by the journal or conference you plan
% to submit to, of course. )

\usepackage{todonotes}


% correct bad hyphenation here
\hyphenation{op-tical net-works semi-conduc-tor}


\begin{document}

%
% paper title
% Titles are generally capitalized except for words such as a, an, and, as,
% at, but, by, for, in, nor, of, on, or, the, to and up, which are usually
% not capitalized unless they are the first or last word of the title.
% Linebreaks \\ can be used within to get better formatting as desired.
% Do not put math or special symbols in the title.
\title{Video Stabilization System Implementation}

% author names and affiliations
% use a multiple column layout for up to three different
% affiliations
\author{\IEEEauthorblockN{Ing. Emmanuel Madrigal}
	\IEEEauthorblockA{Electronic Engineering School\\
		Costa Rica Institute of Technology\\
		Email: emma.madri97@gmail.com}}

% make the title area
\maketitle

% As a general rule, do not put math, special symbols or citations
% in the abstract
\begin{abstract}
	Nowadays more and more video processing applications rely on input
	from non-stationary objects such as mobile phones or car mounted
	cameras. Processing this video directly can reduce the accuracy of
	some algorithms since it will have an inherent shakiness. Video
	stabilization techniques provide a smooth output. This paper describes
	the implementation of one of these video stabilization algorithms and
	the results obtained.
\end{abstract}
\begin{IEEEkeywords} Video Stabilization  \end{IEEEkeywords}
% no keywords

\section{Introduction}

This paper implements the algorithm described
in~\cite{farid1997video}. The goal of this algorithm is to create a
new video sequence where the motion between the frames has been
effectively removed.

\subsection{Motion Estimation Algorithm}

An affine transform can be used to capture a large range of motions
such as translation, scale and rotation. The error function to be
minimized using the affine transform is given by:

\begin{equation*}
\begin{aligned}
E(\overrightarrow{m}) = & \sum_{x, y \in \Omega} [ f(x, y, t) - \\
      & f(m_1 x + m_2y - m_5, m_3x + m_4y + m_6, t - 1) ]^2
\end{aligned}
\end{equation*}

Where $\Omega$ represents the ROI (region of interest), which are the
pixels over which the transfoormation will be calculated

Since this function error is non-linear it cannot be minimized
analytically. Using a truncated Taylor series expansion it can be simplified to:

$$
	E(\overrightarrow{m}) \approx \sum_{x, y \in \Omega} \left[ k - \overrightarrow{c}^T \overrightarrow{m} \right]^2
$$

With:

$$
	k = f_t + xf_x + yf_y
$$

$$
	\overrightarrow{c}^T = (xf_x\ yf_x\ xf_y\ yf_y\ f_x\ f_y)
$$

Differentiating with respect to $\overrightarrow{m}$ and setting the result to zero:

$$
	\overrightarrow{m} \left[ \sum_\Omega \overrightarrow{c}\overrightarrow{c}^T  \right]^{-1} \left[ \sum_\Omega \overrightarrow{c} k \right]
$$

The spatial/temporal derivatives given a pair of frames $f(x, y, y)$ and $f(x, y, t -1)$ are computed as follows:

$$
	f_x(x, y, t) = (0.5f(x, y, t) + 0.5f(x, y, t - 1)) * d(x) * p(y)
$$

$$
	f_y(x, y, t) = (0.5f(x, y, t) + 0.5f(x, y, t - 1)) * p(x) * d(y)
$$

$$
	f_t(x, y, t) = (0.5f(x, y, t) + 0.5f(x, y, t - 1)) * p(x) * p(y)
$$

Where $*$ is the convolution symbol, and $d(\cdot)$ and $p(\cdot)$ are 1-D separatable filters:

$$
	d(x) = (0.5\ -0.5)
$$

$$
	p(x) = (0.5\ 0.5)
$$

\subsection{Large Motion Estimation}

The spatial/temporal derivatives have finite support thus limiting the
amount of motion that can be estimated. A L-level Gaussian pyramid is
built for each frame, $f(x, y, t)$ and $f(x, y, t - 1)$. The motion at
each pyramid level $l$ is used to warp the frame at the higher level,
until the finset level of the pyramid is reached.

If the estimated motion at pyramid level $l$ is
$m_1\ m_2\ m_3\ m_4\ m_5\ m_6$ , then the original frame should be
warped with the affine matrix $A$ and the translation vector
$\overrightarrow{T}$ given by:

$$
	A = \begin{pmatrix} m_1 & m_2 \\ m_3 & m_4 \end{pmatrix}
$$

$$
	T = \begin{pmatrix} 2^{l -1}m_5 \\ 2^{l-1}m_6 \end{pmatrix}
$$

As each pyramid level is processed, the original frame will have to be
repeatedly warped according to the motion estimated on each level. Two affine matrices and the corresponding translation vectors can be combined as follows:

$$
	A = A_2A_1
$$

$$
	\overrightarrow{T} = A_2 \overrightarrow{T_1} + \overrightarrow{T_2}
$$

If the image has different objects moving with different homographies,
only a sectioin of the image can be considered for the previous
algorithms.

\subsection{Other Algorithm}

Altough this paper only focuses on the image stabilization proposed
by~\cite{farid1997video}, other image stabilization algorithms exist.

In~\cite{erturk2003digital} the author proposes an stabilization
algorithm using a Kalman filter.

The authors in~\cite{censi1999image} and~\cite{lee2009video} propose the usage of a feature
tracking algorithm to compensate for the camera's movement.

And in~\cite{liu2009content} the authors estimate the 3D motion of the
camera in order to compensate for this movement.

\subsection{Syntetic Transformations}

An afine transformation~\cite{gonzales1992digital} is a geometric
transformation in which lines and parallelism are preserved. This can
be used to simulate camera motion and other transformation.

Transformation can be represented by a Homography matrix $H$, in which
in order to apply this the tranformation can be obtained by the
operation:

$$
\left[\begin{matrix}x_{new} \\ y_{new} \\ 1 \end{matrix} \right] = H \left[\begin{matrix}x_{orig} \\ y_{orig} \\ 1 \end{matrix} \right]
$$


This transformations include but are not limited to:

\subsubsection{Translation}

$$
H  = \left[\begin{matrix}1 & 0 & tx\\ 0 & 1 & ty \\ 0 & 0 & 1 \end{matrix} \right]
$$

\subsubsection{Scaling}

$$
H  = \left[\begin{matrix}sx & 0 & 0\\ 0 & sy & 0 \\ 0 & 0 & 1 \end{matrix} \right]
$$

\subsubsection{Rotation}

$$
H  = \left[\begin{matrix}cos(\theta) & -sin(\theta) & 0\\ sin(\theta) & cos(\theta) & 0 \\ 0 & 0 & 1 \end{matrix} \right]
$$

These matrices can be combined to obtain a single transformation matrix.

\section{Analysis Result}
\label{sec:resultados}

\subsection{Quantitative Results}
% Accuracy vs frequency/magnitude

In order to quantify the capacity of the algorithm to estimate the
motion against a given transformation, the mean square error for a
given transformation will be calculated. In this case the
transformation matrix itself will be evaluated. For example for a set of frames:

$$
	f_1, f_2, f_3, \dots, f_n
$$

The will have transformations:

$$
	H_{1,2}, H_{2,3}, \ldots, H_{n-1, n}
$$

With $H$ with the form:

$$
	H = \begin{pmatrix} h_{00} & h_{01} & h_{02} \\ h_{10} & h_{11} & h_{12} \\ h_{20} & h_{21} & h_{22} \end{pmatrix}
$$

The mean squared error will be calculated as follows:

$$
	M.S.E = \sum_{i=1}^{n-1} mean\left(H_{i,i+1} - H_{i, i+1}\right)
$$

where $mean$ is the mean of all elements in the matrix.

\subsection{Translation}

The first transformation to be reviewed is the translation, the
results for the algorithm are shown in figure~\ref{fig:trans}. The
syntetic transformation can be varied in terms of the magnitude of the
transformation and the period. Only a transformation in the x axis
is evaluated in this experiment, in which magnitudes from $10$ to
$100$ pixels are tested in three diferent periods. Notice that
since the translation values will be the same the period will vary
the amount that the pixels vary from one frame to the other.

As can be seen the error stays small up to a certain breaking point
after which it starts growing rapidly. The reason for this is that
most likely that there is a certain amount of pixels that the
transformation can be made after which the algorithm starts
failing. This is compunded by the commulative nature of the algorithm,
in which small errors at the start of the can be compunded into a
large enough error that the algorithm is unable to determine a correct
transformation.

%% Translation Only
\begin{figure}[htbp]
	\begin{tikzpicture}
		\begin{axis}[ylabel=MSE, xlabel=Translation Magnitude (pixels)]

			\addplot table[x=t, y=f_10, col sep=comma] {data/translation.csv};
			\addlegendentry{T=10}

			\addplot table[x=t, y=f_20, col sep=comma] {data/translation.csv};
			\addlegendentry{T=20}

			\addplot table[x=t, y=f_30, col sep=comma] {data/translation.csv};
			\addlegendentry{T=30}

		\end{axis}
	\end{tikzpicture}
	\caption{MSE vs Translation Magnitude for Different Periods, with a fixed level of $l=4$, evaluating over $20$ frames for an Image with resolution of $780\time360$}
	\label{fig:trans}
\end{figure}

\subsection{Rotation}

Figure~\ref{fig:rot} shows the same experiment as before, but the
rotation is being modified instead of a translation.

Comparing the max error values and the ``breaking point'' for the
algorithm, the rotation seems a harder to determine its correct value,
this is true for all three values.

%% Rotation Only
\begin{figure}[htbp]
	\begin{tikzpicture}
		\begin{axis}[ylabel=MSE, xlabel=Rotation Magnitude (°)]

			\addplot table[x=r, y=f_10, col sep=comma] {data/rotation.csv};
			\addlegendentry{T=10}

			\addplot table[x=r, y=f_20, col sep=comma] {data/rotation.csv};
			\addlegendentry{T=20}

			\addplot table[x=r, y=f_30, col sep=comma] {data/rotation.csv};
			\addlegendentry{T=30}

		\end{axis}
	\end{tikzpicture}
	\caption{MSE vs Rotation Magnitude for Different Periods, with a fixed level of $l=4$, evaluating over $20$ frames for an Image with resolution of $780\time360$}
	\label{fig:rot}
\end{figure}

\subsection{Scaling}

The scaling runs the scaling parameter in the same way, in this case
the scaling value represents percentage of scaling, due to the
period this will be in both directions. For example a scaling
magnitude of $50\%$ will increase the image up to a size of $150\%$
and down to $50\%$. This is also centered around the center of the
image so the pixels will appear to get both closer and farther away
from this point.

%% Scale Only
\begin{figure}[htbp]
	\begin{tikzpicture}
		\begin{axis}[ylabel=MSE, xlabel=Scaling Magnitude (\%)]

			\addplot table[x=s, y=f_10, col sep=comma] {data/scaling.csv};
			\addlegendentry{T=10}

			\addplot table[x=s, y=f_20, col sep=comma] {data/scaling.csv};
			\addlegendentry{T=20}

			\addplot table[x=s, y=f_30, col sep=comma] {data/scaling.csv};
			\addlegendentry{T=30}

		\end{axis}
	\end{tikzpicture}
	\caption{MSE vs Scaling Magnitude for Different Periods, with a fixed level of $l=4$, evaluating over $20$ frames for an Image with resolution of $780\time360$}
	\label{fig:scale}
\end{figure}

%% Combination

\subsection{Levels}

In order to be able to determinate both coarse and fine movements in
the translation the algorithm proposes the use of of a gaussian
pyramid approach. In which the image is scaled down and up to provide
this. This is done by halfing the image size by $2^l$ times, for
example this means that the image to be processed at level $4$ will
have a size a $1/16$ in both dimensions.

The amount of levels hace a large impact on the magnitude of the
transformation it can determine~\ref{fig:levels}. The ``breaking
point'' for the smallest amount of levels is quite small, for example
for $l=2$ at a translation of $20$ pixels the $MSE$ is already of $135$, while increasing the ammount of levels will mean that ``breaking point'' will be much larger for $l=4$ the MSE doesn't rise above 1 until the translation is of $60$ pixels.

Notice that the smallest amount of levels possible is $0$ which isn't
pictured in the graph, and the largest level is that in which
$pxl=min(\frac{width}{2^l}, \frac{height}{2^l})$ is greater than 1.

%% Levels
\begin{figure}[htbp]
	\begin{tikzpicture}
		\begin{axis}[ylabel=MSE, xlabel=Translation Magnitude (pixels)]

			\addplot table[x=t, y=l_1, col sep=comma] {data/levels.csv};
			\addlegendentry{l=1}

			\addplot table[x=t, y=l_2, col sep=comma] {data/levels.csv};
			\addlegendentry{l=2}

			\addplot table[x=t, y=l_4, col sep=comma] {data/levels.csv};
			\addlegendentry{l=4}

			\addplot table[x=t, y=l_6, col sep=comma] {data/levels.csv};
			\addlegendentry{l=6}

		\end{axis}
	\end{tikzpicture}
	\caption{MSE vs Translation Magnitude for Different Number Pyramid Levels, with a fixed period of T=20, evaluating over 20 frames,  for an Image with resolution of $780\time360$}
	\label{fig:levels}
\end{figure}

% Speed

\subsection{Processing Speed}

The processing time in function of the number of levels can be seen in
figure~\ref{fig:time}, this has a linear behaviour. Since each pyramid
level processes not only iselft but also every pyramid with a lower
value this would be the expected value. One behaviour that is not seen
is the effect of reducing the image size, since this would
theoretically reduce the processing time for the larger pyramid
levels. This could however be attributed to an error in the
implementation.

Altough the system is able to perform at $30\ fps$ for the used images
with a resolution of $780\time360$, the algorithm uses a backwards
approach to transform the frames, which means the processing speed
could be considered real-time but the algorithm itself need the
complete image sequence to operate.

\begin{figure}[htbp]
	\begin{tikzpicture}
		\begin{axis}[ylabel=Time (s), xlabel=Levels]
			\addplot table [x=l, y=t, col sep=comma] {data/time.csv};
		\end{axis}
	\end{tikzpicture}
	\caption{Processing Time per Frame vs Number of Levels for an Image with resolution of $780\time360$}
	\label{fig:time}
\end{figure}

Altough not pictured in the graph, changes in the magnitude of the
transformation matrix dont't affect the processing time.

A parameter not considered in this is the size of the ROI, which is
kept constant for the previous figure.

%% Image/ROI Size vs Speed

\subsection{Qualitative Results}

In figure~\ref{fig:orig} a sequence of frames is shown with syntethic
transformations which includes translation, scaling and rotation. The
same sequence is stabilized as seen in figure~\ref{fig:stab}.

\begin{figure*}
\centering
\begin{subfigure}{.15\paperwidth}
  \centering
  \includegraphics[width=.15\paperwidth]{lenna_orig_0.png}
  \caption{Original image at frame 0}
  \label{fig:orig1}
\end{subfigure}%
\begin{subfigure}{.15\paperwidth}
  \centering
  \includegraphics[width=.15\paperwidth]{lenna_orig_40.png}
  \caption{Original image at frame 40}
  \label{fig:orig2}
\end{subfigure}%
\begin{subfigure}{.15\paperwidth}
  \centering
  \includegraphics[width=.15\paperwidth]{lenna_orig_80.png}
  \caption{Original image at frame 80}
  \label{fig:orig3}
\end{subfigure}%
\begin{subfigure}{.15\paperwidth}
  \centering
  \includegraphics[width=.15\paperwidth]{lenna_orig_120.png}
  \caption{Original image at frame 120}
  \label{fig:orig4}
\end{subfigure}%
\begin{subfigure}{.15\paperwidth}
  \centering
  \includegraphics[width=.15\paperwidth]{lenna_orig_160.png}
  \caption{Original image at frame 160}
  \label{fig:orig5}
\end{subfigure}
\caption{Original image sequence with the following parameters,
  scaling in $x=(M=10, T=30)$, scaling in $y=(M=15, T=40)$,
  translation in $x=(M=70, T=100)$, translation in $y=(M=100, T=150)$, and rotation $\theta=(M=20, T=100)$}
\label{fig:orig}
\end{figure*}

\begin{figure*}
\centering
\begin{subfigure}{.15\paperwidth}
  \centering
  \includegraphics[width=.15\paperwidth]{lenna_stab_0.png}
  \caption{Stabilized image at frame 0}
  \label{fig:stab1}
\end{subfigure}%
\begin{subfigure}{.15\paperwidth}
  \centering
  \includegraphics[width=.15\paperwidth]{lenna_stab_40.png}
  \caption{Stabilized image at frame 40}
  \label{fig:stab2}
\end{subfigure}%
\begin{subfigure}{.15\paperwidth}
  \centering
  \includegraphics[width=.15\paperwidth]{lenna_stab_80.png}
  \caption{Stabilized image at frame 80}
  \label{fig:stab3}
\end{subfigure}%
\begin{subfigure}{.15\paperwidth}
  \centering
  \includegraphics[width=.15\paperwidth]{lenna_stab_120.png}
  \caption{Stabilized image at frame 120}
  \label{fig:stab4}
\end{subfigure}%
\begin{subfigure}{.15\paperwidth}
  \centering
  \includegraphics[width=.15\paperwidth]{lenna_stab_160.png}
  \caption{Stabilized image at frame 160}
  \label{fig:stab5}
\end{subfigure}
\caption{Stabilized image sequence from figure~\ref{fig:orig}, processed with 7 levels}
\label{fig:stab}
\end{figure*}



\section{Conclusion and Future Work}
\label{sec:conclusiones}

The system is able to correctly predict affine transformations when
the magnitude of these are small enough. The use of gaussian pyramids
allows for the detction of larger transformations. These however
% Good for smaller transformations

The processing speed of the algorithm could be considered real-time
but the algorithm itself uses a backwards approach which means that it
needs the complete image sequence to process. 
% Slow, no real time

The region of interest is only processed on a frame-by-frame basis,
and takeing the newest region of interest for all further
processing. This means that there is an error in the transformation
between two frames this will be propagated to all future frames.
% Commulative error needs simple transformations all around

Altough not implemented for this project, the paper shows that using
image enhacement for the different frames this will increases accuracy
in calculating the image processing.
% Image Enhacement, shown by paper to increase accuracy

On of the most important improvements features that could be
implemented for the algorithm would be the usage of a forward
processing technique. This would require removing the backwards
processing for transforming images back to the initial position and
instead transform the base of the images in parallel with the
transformation estimation.
% Forward processing

\bibliographystyle{IEEEtran}
\bibliography{bibliography.bib}

% An example of a floating figure using the graphicx package.
% Note that \label must occur AFTER (or within) \caption.
% For figures, \caption should occur after the \includegraphics.
% Note that IEEEtran v1.7 and later has special internal code that
% is designed to preserve the operation of \label within \caption
% even when the captionsoff option is in effect. However, because
% of issues like this, it may be the safest practice to put all your
% \label just after \caption rather than within \caption{}.
%
% Reminder: the "draftcls" or "draftclsnofoot", not "draft", class
% option should be used if it is desired that the figures are to be
% displayed while in draft mode.
%
%\begin{figure}[!t]
%\centering
%\includegraphics[width=2.5in]{myfigure}
% where an .eps filename suffix will be assumed under latex, 
% and a .pdf suffix will be assumed for pdflatex; or what has been declared
% via \DeclareGraphicsExtensions.
%\caption{Simulation results for the network.}
%\label{fig_sim}
%\end{figure}

% Note that the IEEE typically puts floats only at the top, even when this
% results in a large percentage of a column being occupied by floats.

% An example of a double column floating figure using two subfigures.
% (The subfig.sty package must be loaded for this to work.)
% The subfigure \label commands are set within each subfloat command,
% and the \label for the overall figure must come after \caption.
% \hfil is used as a separator to get equal spacing.
% Watch out that the combined width of all the subfigures on a 
% line do not exceed the text width or a line break will occur.
%
%\begin{figure*}[!t]
%\centering
%\subfloat[Case I]{\includegraphics[width=2.5in]{box}%
%\label{fig_first_case}}
%\hfil
%\subfloat[Case II]{\includegraphics[width=2.5in]{box}%
%\label{fig_second_case}}
%\caption{Simulation results for the network.}
%\label{fig_sim}
%\end{figure*}
%
% Note that often IEEE papersp with subfigures do not employ subfigure
% captions (using the optional argument to \subfloat[]), but instead will
% reference/describe all of them (a), (b), etc., within the main caption.
% Be aware that for subfig.sty to generate the (a), (b), etc., subfigure
% labels, the optional argument to \subfloat must be present. If a
% subcaption is not desired, just leave its contents blank,
% e.g., \subfloat[].

% An example of a floating table. Note that, for IEEE style tables, the
% \caption command should come BEFORE the table and, given that table
% captions serve much like titles, are usually capitalized except for words
% such as a, an, and, as, at, but, by, for, in, nor, of, on, or, the, to
% and up, which are usually not capitalized unless they are the first or
% last word of the caption. Table text will default to \footnotesize as
% the IEEE normally uses this smaller font for tables.
% The \label must come after \caption as always.
%
%\begin{table}[!t]
%% increase table row spacing, adjust to taste
%\renewcommand{\arraystretch}{1.3}
% if using array.sty, it might be a good idea to tweak the value of
% \extrarowheight as needed to properly center the text within the cells
%\caption{An Example of a Table}
%\label{table_example}
%\centering
%% Some packages, such as MDW tools, offer better commands for making tables
%% than the plain LaTeX2e tabular which is used here.
%\begin{tabular}{|c||c|}
%\hline
%One & Two\\
%\hline
%Three & Four\\
%\hline
%\end{tabular}
%\end{table}

% Note that the IEEE does not put floats in the very first column
% - or typically anywhere on the first page for that matter. Also,
% in-text middle ("here") positioning is typically not used, but it
% is allowed and encouraged for Computer Society conferences (but
% not Computer Society journals). Most IEEE journals/conferences use
% top floats exclusively. 
% Note that, LaTeX2e, unlike IEEE journals/conferences, places
% footnotes above bottom floats. This can be corrected via the
% \fnbelowfloat command of the stfloats package.

% trigger a \newpage just before the given reference
% number - used to balance the columns on the last page
% adjust value as needed - may need to be readjusted if
% the document is modified later
%\IEEEtriggeratref{8}
% The "triggered" command can be changed if desired:
%\IEEEtriggercmd{\enlargethispage{-5in}}

% references section

% can use a bibliography generated by BibTeX as a .bbl file
% BibTeX documentation can be easily obtained at:
% http://mirror.ctan.org/biblio/bibtex/contrib/doc/
% The IEEEtran BibTeX style support page is at:
% http://www.michaelshell.org/tex/ieeetran/bibtex/
%\bibliographystyle{IEEEtran}
% argument is your BibTeX string definitions and bibliography database(s)
%\bibliography{IEEEabrv,../bib/paper}
%
% <Or> manually copy in the resultant .bbl file
% set second argument of \begin to the number of references
% (used to reserve space for the reference number labels box)

% that's all folks
\end{document}

